Index: uspace/srv/devman/match.c
===================================================================
--- uspace/srv/devman/match.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/devman/match.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -202,15 +202,16 @@
 	struct stat st;
 	
-	fd = vfs_lookup_open(conf_path, WALK_REGULAR, MODE_READ);
-	if (fd < 0) {
+	int rc = vfs_lookup_open(conf_path, WALK_REGULAR, MODE_READ, &fd);
+	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Unable to open `%s' for reading: %s.",
-		    conf_path, str_error(errno));
+		    conf_path, str_error(rc));
 		goto cleanup;
 	}
 	opened = true;
 	
-	if (vfs_stat(fd, &st) != EOK) {
+	rc = vfs_stat(fd, &st);
+	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Unable to fstat %d: %s.", fd,
-		    str_error(errno));
+		    str_error(rc));
 		goto cleanup;
 	}
@@ -229,8 +230,9 @@
 	}
 	
-	ssize_t read_bytes = vfs_read(fd, (aoff64_t []) {0}, buf, len);
-	if (read_bytes <= 0) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Unable to read file '%s' (%d).", conf_path,
-		    errno);
+	size_t read_bytes;
+	rc = vfs_read(fd, (aoff64_t []) {0}, buf, len, &read_bytes);
+	if (rc != EOK) {
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Unable to read file '%s': %s.", conf_path,
+		    str_error(rc));
 		goto cleanup;
 	}
Index: uspace/srv/devman/util.h
===================================================================
--- uspace/srv/devman/util.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/devman/util.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -35,6 +35,6 @@
 
 #include <ctype.h>
+#include <stdlib.h>
 #include <str.h>
-#include <malloc.h>
 
 extern char *get_abs_path(const char *, const char *, const char *);
Index: uspace/srv/fs/cdfs/cdfs.c
===================================================================
--- uspace/srv/fs/cdfs/cdfs.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/cdfs/cdfs.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -41,4 +41,5 @@
 #include <ns.h>
 #include <errno.h>
+#include <str_error.h>
 #include <stdio.h>
 #include <libfs.h>
@@ -83,5 +84,5 @@
 	    &cdfs_libfs_ops);
 	if (rc != EOK) {
-		printf("%s: Failed to register file system (%d)\n", NAME, rc);
+		printf("%s: Failed to register file system: %s\n", NAME, str_error(rc));
 		return rc;
 	}
Index: uspace/srv/fs/cdfs/cdfs_ops.c
===================================================================
--- uspace/srv/fs/cdfs/cdfs_ops.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/cdfs/cdfs_ops.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -42,5 +42,4 @@
 #include <adt/hash_table.h>
 #include <adt/hash.h>
-#include <malloc.h>
 #include <mem.h>
 #include <loc.h>
@@ -49,4 +48,5 @@
 #include <block.h>
 #include <scsi/mmc.h>
+#include <stdlib.h>
 #include <str.h>
 #include <byteorder.h>
@@ -566,5 +566,5 @@
 }
 
-static bool cdfs_readdir(cdfs_t *fs, fs_node_t *fs_node)
+static int cdfs_readdir(cdfs_t *fs, fs_node_t *fs_node)
 {
 	cdfs_node_t *node = CDFS_NODE(fs_node);
@@ -572,5 +572,5 @@
 	
 	if (node->processed)
-		return true;
+		return EOK;
 	
 	uint32_t blocks = node->size / BLOCK_SIZE;
@@ -582,5 +582,5 @@
 		int rc = block_get(&block, fs->service_id, node->lba + i, BLOCK_FLAGS_NONE);
 		if (rc != EOK)
-			return false;
+			return rc;
 		
 		cdfs_dir_t *dir;
@@ -616,6 +616,8 @@
 			int rc = create_node(&fn, fs, dentry_type,
 			    (node->lba + i) * BLOCK_SIZE + offset);
-			if ((rc != EOK) || (fn == NULL))
-				return false;
+			if (rc != EOK)
+				return rc;
+
+			assert(fn != NULL);
 			
 			cdfs_node_t *cur = CDFS_NODE(fn);
@@ -626,5 +628,5 @@
 			    dir->name_length, node->fs->enc, dentry_type);
 			if (name == NULL)
-				return false;
+				return EIO;
 			
 			// FIXME: check return value
@@ -641,5 +643,5 @@
 	
 	node->processed = true;
-	return true;
+	return EOK;
 }
 
@@ -961,5 +963,5 @@
 
 /** Read the volume descriptors. */
-static bool iso_read_vol_desc(service_id_t sid, cdfs_lba_t altroot,
+static int iso_read_vol_desc(service_id_t sid, cdfs_lba_t altroot,
     uint32_t *rlba, uint32_t *rsize, cdfs_enc_t *enc, char **vol_ident)
 {
@@ -968,5 +970,5 @@
 	int rc = block_get(&block, sid, altroot + 16, BLOCK_FLAGS_NONE);
 	if (rc != EOK)
-		return false;
+		return rc;
 	
 	cdfs_vol_desc_t *vol_desc = (cdfs_vol_desc_t *) block->data;
@@ -980,5 +982,5 @@
 	    (vol_desc->version != 1)) {
 		block_put(block);
-		return false;
+		return ENOTSUP;
 	}
 	
@@ -1000,5 +1002,5 @@
 		 */
 		block_put(block);
-		return false;
+		return ENOTSUP;
 	}
 	
@@ -1006,5 +1008,5 @@
 	if (block_size != BLOCK_SIZE) {
 		block_put(block);
-		return false;
+		return ENOTSUP;
 	}
 	
@@ -1031,15 +1033,16 @@
 	
 	block_put(block);
-	return true;
-}
-
-static bool iso_readfs(cdfs_t *fs, fs_node_t *rfn,
+	return EOK;
+}
+
+static int iso_readfs(cdfs_t *fs, fs_node_t *rfn,
     cdfs_lba_t altroot)
 {
 	cdfs_node_t *node = CDFS_NODE(rfn);
 	
-	if (!iso_read_vol_desc(fs->service_id, altroot, &node->lba,
-	    &node->size, &fs->enc, &fs->vol_ident))
-		return false;
+	int rc = iso_read_vol_desc(fs->service_id, altroot, &node->lba,
+	    &node->size, &fs->enc, &fs->vol_ident);
+	if (rc != EOK)
+		return rc;
 	
 	return cdfs_readdir(fs, rfn);
@@ -1072,5 +1075,5 @@
 	
 	/* Check if there is cdfs in given session */
-	if (!iso_readfs(fs, rfn, altroot))
+	if (iso_readfs(fs, rfn, altroot) != EOK)
 		goto error;
 	
@@ -1125,9 +1128,10 @@
 	uint32_t rsize;
 	cdfs_enc_t enc;
-	if (!iso_read_vol_desc(service_id, altroot, &rlba, &rsize, &enc,
-	    &vol_ident)) {
+	rc = iso_read_vol_desc(service_id, altroot, &rlba, &rsize, &enc,
+	    &vol_ident);
+	if (rc != EOK) {
 		block_cache_fini(service_id);
 		block_fini(service_id);
-		return EIO;
+		return rc;
 	}
 	
Index: uspace/srv/fs/exfat/exfat.c
===================================================================
--- uspace/srv/fs/exfat/exfat.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/exfat/exfat.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -43,4 +43,5 @@
 #include <async.h>
 #include <errno.h>
+#include <str_error.h>
 #include <task.h>
 #include <stdio.h>
@@ -95,5 +96,5 @@
 
 err:
-	printf(NAME ": Failed to register file system (%d)\n", rc);
+	printf(NAME ": Failed to register file system: %s\n", str_error(rc));
 	return rc;
 }
Index: uspace/srv/fs/exfat/exfat_directory.c
===================================================================
--- uspace/srv/fs/exfat/exfat_directory.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/exfat/exfat_directory.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -43,5 +43,5 @@
 #include <byteorder.h>
 #include <mem.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <str.h>
 #include <align.h>
Index: uspace/srv/fs/exfat/exfat_fat.c
===================================================================
--- uspace/srv/fs/exfat/exfat_fat.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/exfat/exfat_fat.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -48,6 +48,6 @@
 #include <assert.h>
 #include <fibril_synch.h>
-#include <malloc.h>
 #include <mem.h>
+#include <stdlib.h>
 #include <str.h>
 
Index: uspace/srv/fs/exfat/exfat_idx.c
===================================================================
--- uspace/srv/fs/exfat/exfat_idx.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/exfat/exfat_idx.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -45,5 +45,5 @@
 #include <assert.h>
 #include <fibril_synch.h>
-#include <malloc.h>
+#include <stdlib.h>
 
 /** Each instance of this type describes one interval of freed VFS indices. */
Index: uspace/srv/fs/exfat/exfat_ops.c
===================================================================
--- uspace/srv/fs/exfat/exfat_ops.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/exfat/exfat_ops.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -59,6 +59,6 @@
 #include <fibril_synch.h>
 #include <align.h>
-#include <malloc.h>
 #include <stdio.h>
+#include <stdlib.h>
 
 /** Mutex protecting the list of cached free FAT nodes. */
Index: uspace/srv/fs/fat/fat.c
===================================================================
--- uspace/srv/fs/fat/fat.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/fat/fat.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -43,4 +43,5 @@
 #include <async.h>
 #include <errno.h>
+#include <str_error.h>
 #include <task.h>
 #include <stdio.h>
@@ -95,5 +96,5 @@
 	
 err:
-	printf(NAME ": Failed to register file system (%d)\n", rc);
+	printf(NAME ": Failed to register file system: %s\n", str_error(rc));
 	return rc;
 }
Index: uspace/srv/fs/fat/fat_fat.c
===================================================================
--- uspace/srv/fs/fat/fat_fat.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/fat/fat_fat.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -48,6 +48,6 @@
 #include <assert.h>
 #include <fibril_synch.h>
-#include <malloc.h>
 #include <mem.h>
+#include <stdlib.h>
 
 #define IS_ODD(number)	(number & 0x1)
Index: uspace/srv/fs/fat/fat_idx.c
===================================================================
--- uspace/srv/fs/fat/fat_idx.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/fat/fat_idx.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -45,5 +45,5 @@
 #include <assert.h>
 #include <fibril_synch.h>
-#include <malloc.h>
+#include <stdlib.h>
 
 /** Each instance of this type describes one interval of freed VFS indices. */
Index: uspace/srv/fs/fat/fat_ops.c
===================================================================
--- uspace/srv/fs/fat/fat_ops.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/fat/fat_ops.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -56,5 +56,5 @@
 #include <fibril_synch.h>
 #include <align.h>
-#include <malloc.h>
+#include <stdlib.h>
 
 #define FAT_NODE(node)	((node) ? (fat_node_t *) (node)->data : NULL)
Index: uspace/srv/fs/locfs/locfs.c
===================================================================
--- uspace/srv/fs/locfs/locfs.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/locfs/locfs.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -44,4 +44,5 @@
 #include <async.h>
 #include <errno.h>
+#include <str_error.h>
 #include <task.h>
 #include <libfs.h>
@@ -87,5 +88,5 @@
 	    &locfs_libfs_ops);
 	if (rc != EOK) {
-		printf("%s: Failed to register file system (%d)\n", NAME, rc);
+		printf("%s: Failed to register file system: %s\n", NAME, str_error(rc));
 		return rc;
 	}
Index: uspace/srv/fs/locfs/locfs_ops.c
===================================================================
--- uspace/srv/fs/locfs/locfs_ops.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/locfs/locfs_ops.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -39,5 +39,5 @@
 #include <stdbool.h>
 #include <errno.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <str.h>
 #include <libfs.h>
Index: uspace/srv/fs/mfs/mfs.c
===================================================================
--- uspace/srv/fs/mfs/mfs.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/mfs/mfs.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -44,4 +44,5 @@
 #include <async.h>
 #include <errno.h>
+#include <str_error.h>
 #include <task.h>
 #include <stdio.h>
@@ -97,5 +98,5 @@
 
 err:
-	printf(NAME ": Failed to register file system (%d)\n", rc);
+	printf(NAME ": Failed to register file system: %s\n", str_error(rc));
 	return rc;
 }
Index: uspace/srv/fs/mfs/mfs.h
===================================================================
--- uspace/srv/fs/mfs/mfs.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/mfs/mfs.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -39,7 +39,7 @@
 #include <libfs.h>
 #include <adt/list.h>
-#include <malloc.h>
 #include <mem.h>
 #include <stdio.h>
+#include <stdlib.h>
 #include <errno.h>
 #include <assert.h>
Index: uspace/srv/fs/tmpfs/tmpfs.c
===================================================================
--- uspace/srv/fs/tmpfs/tmpfs.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/tmpfs/tmpfs.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -46,4 +46,5 @@
 #include <async.h>
 #include <errno.h>
+#include <str_error.h>
 #include <stdio.h>
 #include <task.h>
@@ -89,5 +90,5 @@
 	    &tmpfs_libfs_ops);
 	if (rc != EOK) {
-		printf(NAME ": Failed to register file system (%d)\n", rc);
+		printf(NAME ": Failed to register file system: %s\n", str_error(rc));
 		return rc;
 	}
Index: uspace/srv/fs/udf/udf.c
===================================================================
--- uspace/srv/fs/udf/udf.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/udf/udf.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -41,4 +41,5 @@
 #include <async.h>
 #include <errno.h>
+#include <str_error.h>
 #include <task.h>
 #include <libfs.h>
@@ -96,5 +97,5 @@
 	
 err:
-	log_msg(LOG_DEFAULT, LVL_FATAL, "Failed to register file system (%d)", rc);
+	log_msg(LOG_DEFAULT, LVL_FATAL, "Failed to register file system: %s", str_error(rc));
 	return rc;
 }
Index: uspace/srv/fs/udf/udf_file.c
===================================================================
--- uspace/srv/fs/udf/udf_file.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/udf/udf_file.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -38,5 +38,5 @@
 #include <libfs.h>
 #include <errno.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <inttypes.h>
 #include <io/log.h>
Index: uspace/srv/fs/udf/udf_idx.c
===================================================================
--- uspace/srv/fs/udf/udf_idx.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/udf/udf_idx.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -40,5 +40,5 @@
 #include <assert.h>
 #include <fibril_synch.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <adt/hash_table.h>
 #include <adt/hash.h>
Index: uspace/srv/fs/udf/udf_ops.c
===================================================================
--- uspace/srv/fs/udf/udf_ops.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/udf/udf_ops.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -51,5 +51,5 @@
 #include <fibril_synch.h>
 #include <align.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <inttypes.h>
 #include <io/log.h>
Index: uspace/srv/fs/udf/udf_osta.c
===================================================================
--- uspace/srv/fs/udf/udf_osta.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/udf/udf_osta.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -45,5 +45,5 @@
  */
 
-#include <malloc.h>
+#include <stdlib.h>
 #include <str.h>
 #include <macros.h>
Index: uspace/srv/fs/udf/udf_volume.c
===================================================================
--- uspace/srv/fs/udf/udf_volume.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/fs/udf/udf_volume.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -39,6 +39,6 @@
 #include <libfs.h>
 #include <errno.h>
+#include <stdlib.h>
 #include <str.h>
-#include <malloc.h>
 #include <mem.h>
 #include <inttypes.h>
Index: uspace/srv/hid/compositor/compositor.c
===================================================================
--- uspace/srv/hid/compositor/compositor.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/compositor/compositor.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -44,5 +44,5 @@
 #include <align.h>
 #include <as.h>
-#include <malloc.h>
+#include <stdlib.h>
 
 #include <atomic.h>
Index: uspace/srv/hid/console/console.c
===================================================================
--- uspace/srv/hid/console/console.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/console/console.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -47,8 +47,8 @@
 #include <io/output.h>
 #include <align.h>
-#include <malloc.h>
 #include <as.h>
 #include <task.h>
 #include <fibril_synch.h>
+#include <stdlib.h>
 #include "console.h"
 
@@ -119,6 +119,6 @@
 static int cons_open(con_srvs_t *, con_srv_t *);
 static int cons_close(con_srv_t *);
-static int cons_read(con_srv_t *, void *, size_t);
-static int cons_write(con_srv_t *, void *, size_t);
+static int cons_read(con_srv_t *, void *, size_t, size_t *);
+static int cons_write(con_srv_t *, void *, size_t, size_t *);
 static void cons_sync(con_srv_t *);
 static void cons_clear(con_srv_t *);
@@ -338,5 +338,5 @@
 }
 
-static int cons_read(con_srv_t *srv, void *buf, size_t size)
+static int cons_read(con_srv_t *srv, void *buf, size_t size, size_t *nread)
 {
 	uint8_t *bbuf = buf;
@@ -378,8 +378,9 @@
 	}
 	
-	return size;
-}
-
-static int cons_write(con_srv_t *srv, void *data, size_t size)
+	*nread = size;
+	return EOK;
+}
+
+static int cons_write(con_srv_t *srv, void *data, size_t size, size_t *nwritten)
 {
 	console_t *cons = srv_to_console(srv);
@@ -389,5 +390,6 @@
 		cons_write_char(cons, str_decode(data, &off, size));
 	
-	return size;
+	*nwritten = size;
+	return EOK;
 }
 
Index: uspace/srv/hid/input/input.c
===================================================================
--- uspace/srv/hid/input/input.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/input/input.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -37,30 +37,31 @@
  */
 
+#include <adt/fifo.h>
 #include <adt/list.h>
-#include <stdbool.h>
+#include <async.h>
+#include <config.h>
+#include <errno.h>
+#include <fibril.h>
 #include <fibril_synch.h>
+#include <io/chardev.h>
+#include <io/console.h>
+#include <io/keycode.h>
 #include <ipc/services.h>
 #include <ipc/input.h>
-#include <config.h>
+#include <loc.h>
+#include <ns.h>
+#include <stdbool.h>
 #include <stdio.h>
 #include <stdlib.h>
-#include <ns.h>
-#include <async.h>
-#include <errno.h>
-#include <adt/fifo.h>
-#include <io/console.h>
-#include <io/keycode.h>
-#include <loc.h>
 #include <str_error.h>
-#include <char_dev_iface.h>
-#include <fibril.h>
-#include "layout.h"
+
+#include "input.h"
 #include "kbd.h"
 #include "kbd_port.h"
 #include "kbd_ctl.h"
+#include "layout.h"
 #include "mouse.h"
 #include "mouse_proto.h"
 #include "serial.h"
-#include "input.h"
 
 #define NUM_LAYOUTS  4
@@ -364,6 +365,5 @@
 }
 
-static void kconsole_event_handler(ipc_callid_t callid, ipc_call_t *call,
-    void *arg)
+static void kconsole_event_handler(ipc_call_t *call, void *arg)
 {
 	if (IPC_GET_ARG1(*call)) {
@@ -536,6 +536,8 @@
 	while (true) {
 		uint8_t data;
-
-		char_dev_read(sdev->sess, &data, sizeof(data));
+		size_t nread;
+
+		chardev_read(sdev->chardev, &data, sizeof(data), &nread);
+		/* XXX Handle error */
 		kbd_push_data(sdev->kdev, data);
 	}
@@ -552,4 +554,5 @@
 {
 	bool match = false;
+	int rc;
 
 	serial_dev_t *sdev = serial_dev_new();
@@ -559,5 +562,5 @@
 	sdev->kdev->svc_id = service_id;
 	
-	int rc = loc_service_get_name(service_id, &sdev->kdev->svc_name);
+	rc = loc_service_get_name(service_id, &sdev->kdev->svc_name);
 	if (rc != EOK)
 		goto fail;
@@ -582,4 +585,12 @@
 		sdev->sess = loc_service_connect(service_id, INTERFACE_DDF,
 		    IPC_FLAG_BLOCKING);
+
+		rc = chardev_open(sdev->sess, &sdev->chardev);
+		if (rc != EOK) {
+			async_hangup(sdev->sess);
+			sdev->sess = NULL;
+			list_remove(&sdev->link);
+			goto fail;
+		}
 
 		fid_t fid = fibril_create(serial_consumer, sdev);
@@ -816,6 +827,6 @@
 	int rc = loc_register_cat_change_cb(cat_change_cb);
 	if (rc != EOK) {
-		printf("%s: Failed registering callback for device discovery. "
-		    "(%d)\n", NAME, rc);
+		printf("%s: Failed registering callback for device discovery: "
+		    "%s\n", NAME, str_error(rc));
 		return rc;
 	}
Index: uspace/srv/hid/input/port/chardev.c
===================================================================
--- uspace/srv/hid/input/port/chardev.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/input/port/chardev.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -35,8 +35,9 @@
  */
 
-#include <ipc/char.h>
 #include <async.h>
+#include <errno.h>
+#include <fibril.h>
+#include <io/chardev.h>
 #include <loc.h>
-#include <errno.h>
 #include <stdio.h>
 #include "../input.h"
@@ -44,8 +45,8 @@
 #include "../kbd.h"
 
-static void kbd_port_events(ipc_callid_t iid, ipc_call_t *icall, void *arg);
+static int kbd_port_fibril(void *);
 
 static int chardev_port_init(kbd_dev_t *);
-static void chardev_port_write(uint8_t data);
+static void chardev_port_write(uint8_t);
 
 kbd_port_ops_t chardev_port = {
@@ -56,4 +57,5 @@
 static kbd_dev_t *kbd_dev;
 static async_sess_t *dev_sess;
+static chardev_t *chardev;
 
 /** List of devices to try connecting to. */
@@ -70,6 +72,6 @@
 {
 	service_id_t service_id;
-	async_exch_t *exch;
 	unsigned int i;
+	fid_t fid;
 	int rc;
 	
@@ -96,22 +98,20 @@
 	}
 	
-	exch = async_exchange_begin(dev_sess);
-	if (exch == NULL) {
-		printf("%s: Failed starting exchange with device\n", NAME);
+	rc = chardev_open(dev_sess, &chardev);
+	if (rc != EOK) {
+		printf("%s: Failed opening character device\n", NAME);
 		async_hangup(dev_sess);
 		return ENOMEM;
 	}
 	
-	port_id_t port;
-	rc = async_create_callback_port(exch, INTERFACE_CHAR_CB, 0, 0,
-	    kbd_port_events, NULL, &port);
-	
-	async_exchange_end(exch);
-	
-	if (rc != 0) {
-		printf("%s: Failed to create callback from device\n", NAME);
+	fid = fibril_create(kbd_port_fibril, NULL);
+	if (fid == 0) {
+		printf("%s: Failed creating fibril\n", NAME);
+		chardev_close(chardev);
 		async_hangup(dev_sess);
-		return -1;
+		return ENOMEM;
 	}
+
+	fibril_add_ready(fid);
 	
 	printf("%s: Found input device '%s'\n", NAME, in_devs[i]);
@@ -121,40 +121,32 @@
 static void chardev_port_write(uint8_t data)
 {
-	async_exch_t *exch = async_exchange_begin(dev_sess);
-	if (exch == NULL) {
-		printf("%s: Failed starting exchange with device\n", NAME);
+	int rc;
+	size_t nwr;
+
+	rc = chardev_write(chardev, &data, sizeof(data), &nwr);
+	if (rc != EOK || nwr != sizeof(data)) {
+		printf("%s: Failed writing to character device\n", NAME);
 		return;
-	}
-
-	async_msg_1(exch, CHAR_WRITE_BYTE, data);
-	async_exchange_end(exch);
-}
-
-static void kbd_port_events(ipc_callid_t iid, ipc_call_t *icall, void *arg)
-{
-	/* Ignore parameters, the connection is already opened */
-	while (true) {
-
-		ipc_call_t call;
-		ipc_callid_t callid = async_get_call(&call);
-		
-		if (!IPC_GET_IMETHOD(call)) {
-			/* TODO: Handle hangup */
-			return;
-		}
-
-		int retval = EOK;
-
-		switch (IPC_GET_IMETHOD(call)) {
-		case CHAR_NOTIF_BYTE:
-			kbd_push_data(kbd_dev, IPC_GET_ARG1(call));
-			break;
-		default:
-			retval = ENOENT;
-		}
-		async_answer_0(callid, retval);
 	}
 }
 
+static int kbd_port_fibril(void *arg)
+{
+	int rc;
+	size_t nread;
+	uint8_t b;
+
+	while (true) {
+		rc = chardev_read(chardev, &b, sizeof(b), &nread);
+		if (rc != EOK || nread != sizeof(b)) {
+			printf("%s: Error reading data", NAME);
+			continue;
+		}
+
+		kbd_push_data(kbd_dev, b);
+	}
+
+	return 0;
+}
 
 /**
Index: uspace/srv/hid/input/proto/mousedev.c
===================================================================
--- uspace/srv/hid/input/proto/mousedev.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/input/proto/mousedev.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -38,9 +38,9 @@
 #include <stdio.h>
 #include <vfs/vfs_sess.h>
-#include <malloc.h>
 #include <async.h>
 #include <errno.h>
 #include <ipc/mouseev.h>
 #include <loc.h>
+#include <stdlib.h>
 #include "../mouse.h"
 #include "../mouse_port.h"
Index: uspace/srv/hid/input/serial.h
===================================================================
--- uspace/srv/hid/input/serial.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/input/serial.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -39,4 +39,5 @@
 
 #include <async.h>
+#include <io/chardev.h>
 #include "kbd.h"
 
@@ -45,4 +46,5 @@
 	link_t link;
 	async_sess_t *sess;
+	chardev_t *chardev;
 } serial_dev_t;
 
Index: uspace/srv/hid/isdv4_tablet/isdv4.c
===================================================================
--- uspace/srv/hid/isdv4_tablet/isdv4.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/isdv4_tablet/isdv4.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -27,9 +27,11 @@
  */
 
-#include <char_dev_iface.h>
+#include <async.h>
 #include <errno.h>
+#include <io/chardev.h>
+#include <mem.h>
+#include <stdbool.h>
+#include <stdint.h>
 #include <stdlib.h>
-#include <mem.h>
-#include <thread.h>
 
 #include "isdv4.h"
@@ -296,9 +298,12 @@
 	bool reading = true;
 	while (reading) {
-		ssize_t read = char_dev_read(state->sess, state->buf + state->buf_end,
-		    state->buf_size - state->buf_end);
-		if (read < 0)
+		size_t nread;
+		int rc;
+
+		rc = chardev_read(state->chardev, state->buf + state->buf_end,
+		    state->buf_size - state->buf_end, &nread);
+		if (rc != EOK && nread == 0)
 			return EIO;
-		state->buf_end += read;
+		state->buf_end += nread;
 
 		size_t i = 0;
@@ -355,7 +360,12 @@
 	return EOK;
 }
-static bool write_command(async_sess_t *sess, uint8_t command)
-{
-	return char_dev_write(sess, &command, 1) == 1;
+
+static bool write_command(chardev_t *chardev, uint8_t command)
+{
+	int rc;
+	size_t nwr;
+
+	rc = chardev_write(chardev, &command, 1, &nwr);
+	return rc == EOK;
 }
 
@@ -363,9 +373,22 @@
     isdv4_event_fn event_fn)
 {
+	chardev_t *chardev;
+	int rc;
+
+	rc = chardev_open(sess, &chardev);
+	if (rc != EOK)
+		return rc;
+
 	memset(state, 0, sizeof(isdv4_state_t));
+
 	state->sess = sess;
+	state->chardev = chardev;
+
 	state->buf = malloc(BUF_SIZE);
-	if (state->buf == NULL)
+	if (state->buf == NULL) {
+		chardev_close(chardev);
 		return ENOMEM;
+	}
+
 	state->buf_size = BUF_SIZE;
 	state->emit_event_fn = event_fn;
@@ -375,11 +398,11 @@
 int isdv4_init_tablet(isdv4_state_t *state)
 {
-	if (!write_command(state->sess, CMD_STOP))
+	if (!write_command(state->chardev, CMD_STOP))
 		return EIO;
 
-	thread_usleep(250000); /* 250 ms */
+	async_usleep(250000); /* 250 ms */
 
 	// FIXME: Read all possible garbage before sending commands
-	if (!write_command(state->sess, CMD_QUERY_STYLUS))
+	if (!write_command(state->chardev, CMD_QUERY_STYLUS))
 		return EIO;
 
@@ -388,5 +411,5 @@
 		return rc;
 
-	if (!write_command(state->sess, CMD_QUERY_TOUCH))
+	if (!write_command(state->chardev, CMD_QUERY_TOUCH))
 		return EIO;
 
@@ -395,5 +418,5 @@
 		return rc;
 
-	if (!write_command(state->sess, CMD_START))
+	if (!write_command(state->chardev, CMD_START))
 		return EIO;
 
Index: uspace/srv/hid/isdv4_tablet/isdv4.h
===================================================================
--- uspace/srv/hid/isdv4_tablet/isdv4.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/isdv4_tablet/isdv4.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -27,6 +27,9 @@
  */
 
-#ifndef __ISDV4_H__
-#define __ISDV4_H__
+#ifndef ISDV4_H_
+#define ISDV4_H_
+
+#include <async.h>
+#include <io/chardev.h>
 
 typedef struct isdv4_event isdv4_event_t;
@@ -56,6 +59,8 @@
 	bool finger1_pressed; /* Reported as touch button 1 */
 
-	/* Session to the serial device */
+	/** Session with the serial device */
 	async_sess_t *sess;
+	/** Character device */
+	chardev_t *chardev;
 
 	/* Receive buffer state */
@@ -64,5 +69,5 @@
 	size_t buf_end;
 
-	/* Callbacks */
+	/** Callbacks */
 	isdv4_event_fn emit_event_fn;
 } isdv4_state_t;
Index: uspace/srv/hid/isdv4_tablet/main.c
===================================================================
--- uspace/srv/hid/isdv4_tablet/main.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/isdv4_tablet/main.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -27,13 +27,12 @@
  */
 
-#include <char_dev_iface.h>
+#include <async.h>
 #include <errno.h>
-#include <ipc/serial_ctl.h>
+#include <fibril_synch.h>
+#include <io/serial.h>
+#include <ipc/mouseev.h>
 #include <loc.h>
+#include <stddef.h>
 #include <stdio.h>
-#include <fibril_synch.h>
-#include <abi/ipc/methods.h>
-#include <ipc/mouseev.h>
-#include <inttypes.h>
 #include <task.h>
 
@@ -179,4 +178,5 @@
 	sysarg_t baud = 38400;
 	service_id_t svc_id;
+	serial_t *serial;
 	char *serial_port_name = NULL;
 
@@ -268,11 +268,14 @@
 	if (!sess) {
 		fprintf(stderr, "Failed connecting to service\n");
-	}
-
-	async_exch_t *exch = async_exchange_begin(sess);
-	rc = async_req_4_0(exch, SERIAL_SET_COM_PROPS, baud,
-	    SERIAL_NO_PARITY, 8, 1);
-	async_exchange_end(exch);
-
+		return 2;
+	}
+
+	rc = serial_open(sess, &serial);
+	if (rc != EOK) {
+		fprintf(stderr, "Failed opening serial port\n");
+		return 2;
+	}
+
+	rc = serial_set_comm_props(serial, baud, SERIAL_NO_PARITY, 8, 1);
 	if (rc != EOK) {
 		fprintf(stderr, "Failed setting serial properties\n");
Index: uspace/srv/hid/output/Makefile
===================================================================
--- uspace/srv/hid/output/Makefile	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/output/Makefile	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -35,7 +35,4 @@
 	ctl/serial.c \
 	port/ega.c \
-	port/kchar.c \
-	port/niagara.c \
-	port/ski.c \
 	port/chardev.c \
 	proto/vt100.c \
Index: uspace/srv/hid/output/ctl/serial.c
===================================================================
--- uspace/srv/hid/output/ctl/serial.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/output/ctl/serial.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -105,4 +105,11 @@
 }
 
+static void serial_flush(outdev_t *dev)
+{
+	vt100_state_t *state = (vt100_state_t *) dev->data;
+
+	vt100_flush(state);
+}
+
 static outdev_ops_t serial_ops = {
 	.yield = serial_yield,
@@ -111,13 +118,14 @@
 	.get_caps = serial_get_caps,
 	.cursor_update = serial_cursor_update,
-	.char_update = serial_char_update
+	.char_update = serial_char_update,
+	.flush = serial_flush
 };
 
 int serial_init(vt100_putchar_t putchar_fn,
-    vt100_control_puts_t control_puts_fn)
+    vt100_control_puts_t control_puts_fn, vt100_flush_t flush_fn)
 {
 	vt100_state_t *state =
 	    vt100_state_create(SERIAL_COLS, SERIAL_ROWS, putchar_fn,
-	    control_puts_fn);
+	    control_puts_fn, flush_fn);
 	if (state == NULL)
 		return ENOMEM;
Index: uspace/srv/hid/output/ctl/serial.h
===================================================================
--- uspace/srv/hid/output/ctl/serial.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/output/ctl/serial.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,5 +36,5 @@
 #include "../proto/vt100.h"
 
-extern int serial_init(vt100_putchar_t, vt100_control_puts_t);
+extern int serial_init(vt100_putchar_t, vt100_control_puts_t, vt100_flush_t);
 
 #endif
